#ifndef DEBUG_H
#define DEBUG_H
//include this file in stddefs.h


#ifndef NDEBUG

  void _AssertHandler( const char * CszFileName, word wLineNumber );

  #define ASSERT(flag) if ( !( flag ) ) { _AssertHandler(__FILE__, __LINE__ ); }
/*
  \
    if (flag)          \
      NULL;            \
    else               \
      _AssertHandler(__FILE__, __LINE__)
*/

#else

  #define ASSERT(flag) NULL

#endif


#ifndef NDEBUG

  void _MemCheckHandler( const char * CszFileName, word wLineNumber );

  #define MEMCHECK() _MemCheckHandler(__FILE__, __LINE__)

#else

  #define MEMCHECK() NULL

#endif

void ExitWithErrorMessage( const char * CszErrorMessage );
void UseYakNewHandler( void );

typedef int debugLevel_t;

#define BASE_DEBUG_LEVEL 0
#define NO_DEBUG_MESSAGES -1

void InitDebugSystem( const char * CszLogFilename, debugLevel_t tNewDebugLevel = BASE_DEBUG_LEVEL );
void LogDebugMessage( debugLevel_t tMessageLevel, const char * CszFormat, ... );
void CloseDebugSystem( void );


#endif


