#ifndef FEVENT_H

#define FEVENT_H

#include "factor.h"
#include "event.h"

#define MAX_FEVENTS 10

//@doc
/*
@class A facingEvent is to a regular <c event> as a <c facingActor> is to a regular <c actor>;
it displays the correct image depending on its direction of motion.
@base public | facingActor
*/
class facingEvent :
  public facingActor {
protected:
  //@access Protected Members
  //@cmember Live or dead status of the event
  bFlag bfIsStillAlive( void );
  //@cmember Removes the event from the <c animap>
  void Die( void );
public:
  //@cmember Event type
  event::eventType eEventType;
  //@cmember Default constructor
  facingEvent();
  //@cmember Copy constructor
  facingEvent( const facingEvent * pfvnCopyFrom );
  //@cmember Default destructor
  virtual ~facingEvent();
  //@cmember Advances the facingEvent
  virtual void Advance( void );
  //@cmember Adds a copy of this event to an <c animap>
  void AddCopyAt( animap * pmap, mapCoordX_t mcx, mapCoordY_t mcy, event::eventType eNewEventType ) const;
};
#endif
