#include "yaklib.h"
//@doc

/*
@class Maintenance class used to modify existing <c yakLib> objects
*/
class yakLibMaintenance
{
public:
  //@access Public Members
  //@cmember Lists the files in a <c yakLib>
  static void ListFiles( yakLib * plib, char * pcMask = "*.*" );
  //@cmember Puts the filenames contained in a <c yakLib> into a buffer
  static void SpewFilenamesToBuffer( yakLib * plib, int * piNumFiles, char *** pppcFileNames );
  //@cmember Copies a yakIcons version 2.xx <c yakLib> to a yakIcons 3.xx <c yakLib>
  static bFlag bfCopy2To3( char * pcOldFilename, char * pcNewFileName );
  //@cmember Deletes a list of files from a <c yakLib>
  static bFlag bfDeleteFiles( yakLib * plib, int iNumberToDelete, char ** ppcFilesToDelete );
  //@cmember Adds a list of files to a <c yakLib>
  static bFlag bfAddFiles( yakLib * plib, int iNumberToAdd, char ** ppcFilesToAdd );
};

bFlag bfFitsMask( char * pcTestString, char * pcMask );
void SpewDirectoryNamesToBuffer( int * piNumFiles, char *** pppcFilenames );
bFlag bfIsInList( char * pcStringToMatch, int iNumberInTryList, char **ppcTryList );
