#ifndef YAKARRAY_H
#define YAKARRAY_H

#include "stddefs.h"
#include <mem.h>

template <class T>
class yakArray {
  int iSize;
  T * ptData;
public:
	yakArray( void ) { iSize = 0; ptData = NULL; };
  void DeAllocate( void ) { if ( iSize ) { delete[] ptData; iSize = 0; } };
  void Allocate( int iNewSize ) { DeAllocate(); ptData = new T[ iNewSize ]; if( ptData ) iSize = iNewSize; };
  ~yakArray( void ) { DeAllocate(); };
  int iGetSize( void ) const { return iSize; };
  T& operator[]( int i ) const { ASSERT( i < iSize ); return ptData[ i ]; };
  T* ptBase( void ) const { return ptData; };
  void SetDataToZero( void ) { if( ptData ) { memset( ptData, 0, iSize * sizeof( T ) ); } };
};

#endif