#ifndef YAKPANEL_H
#define YAKPANEL_H

#include "stddefs.h"
#include "yakwin.h"
#include "gadgets.h"

//@doc

/*
@class A <c yakWindow> holding a <c gadgetList>, a yakPanel is a movable window which can
be extremely useful for control panels, menus, etc.

@base public | yakWindow
@base public | gadgetList
*/
class yakPanel : public yakWindow, public gadgetList
{
public:
  //@cmember Specific constructor
  yakPanel( screenCoordX_t scxLeft, screenCoordY_t scyTop, screenCoordX_t scxRight, screenCoordY_t scyBottom );
  //@cmember Interprets a given key command
  virtual gadgetID_t gidInterpretKeyStroke( char c );
  //@cmember Acts on mouse status, if necessary
  virtual gadgetID_t gidInterpretMouseClick( void );
  //@cmember Draws the yakPanel to the given page at its current position
  virtual void Draw( pageHandle_t pagPage );
  //@cmember Returns the yakPanels <c gadgetList> status
  virtual gadgetID_t gidStatus( void );
  //@cmember default destructur
  virtual ~yakPanel( void );
};

#endif
