#ifndef YAKPRIM_H
#define YAKPRIM_H

#include "stddefs.h"
#include "xlib.h"
#include "xline.h"
#include "xrect.h"
#include "xpoint.h"
//@doc
//@class A static-member-only namespace holding graphics primitives.
class yakPrimitive {
  //@access Private Members
  //@cmember Private constructor, since it's a maintenance class (so none can be created)
  yakPrimitive( void );
public:
  //@access Public Members
  //@cmember Draws a rectangle of the given color
  static void DrawBox( pageHandle_t pagPage, screenCoordX_t scxLeft, screenCoordY_t scyTop, screenCoordX_t scxRight, screenCoordY_t scyBottom, color_t colColor );
  //@member DrawLine | Draws a line between two points
  inline static void DrawLine( pageHandle_t pagPage, screenCoordX_t scxOrigin, screenCoordY_t scyOrigin, screenCoordX_t scxDestination, screenCoordY_t scyDestination, color_t colColor ) { x_line( scxOrigin, scyOrigin, scxDestination, scyDestination, colColor, pagPage ); };
  //@member FillRectangle | Fills a rectangle with a solid color
  inline static void FillRectangle( pageHandle_t pagPage, screenCoordX_t scxLeft, screenCoordY_t scyTop, screenCoordX_t scxRight, screenCoordY_t scyBottom, color_t colColor ) { x_rect_fill( scxLeft, scyTop, scxRight, scyBottom, pagPage, colColor ); };
  //@member colGetPixel | Gets the color of a pixel on the screen
  inline static color_t colGetPixel( pageHandle_t pagPage, screenCoordX_t scx, screenCoordY_t scy ) { return ( ( color_t )x_get_pix( scx, scy, pagPage ) ); };
  //@member PutPixel | Puts a pixel of a given color to the screen
  inline static void PutPixel( pageHandle_t pagPage, screenCoordX_t scx, screenCoordY_t scy, color_t colColor ) { x_put_pix( scx, scy, pagPage, colColor ); };
  //@cmember Sets the clipping rectangle for clipped draws
  static void SetClippingRectangle( screenCoordX_t scxLeft, screenCoordY_t scyTop, screenCoordX_t scxRight, screenCoordY_t scyBottom );
};

#endif
