#ifndef YCONFIG_H
#define YCONFIG_H

#include "stddefs.h"
//@doc

/*
@class A flexible configuration file similar to .INI files, the yakConfigFile is used
primarily to store configuration data for games or utilities.
*/
class yakConfigFile {
  //@access Private Members
  //@cmember Holds the filename of the file
  char acMyPath[ 255 ];
public:
  //@access Public Members
  //@cmember Specific constructor
  yakConfigFile( const char * CszNewFilename );
  //@cmember Sets the file name of the configuration file.
  void SetFilename( const char * CszNewFilename );
  //@cmember Writes an ascii string to a profile position
  void WriteProfileString( const char * CszHeading, const char * CszEntry, const char * CszValue ) const;
  //@cmember Reads an ascii string from a profile position
  const char * CszGetProfileString( const char * CszHeading, const char * CszEntry ) const;
  //@cmember writes an integer to a profile position
  void WriteProfileInt( const char * CszHeading, const char * CszEntry, const int CiValue ) const;
  //@cmember gets an integer from a profile position.
  const int CiGetProfileInt( const char * CszHeading, const char * CszEntry ) const;
};

#endif
