#include "yakicons.h"
#include "demorts.h"
#include <conio.h>

#ifdef __WATCOMC__
int random( int iLimit ) { return rand() % iLimit; };
#endif

extern yakLib libDemo;
extern yakFont fntDemo;

struct screenPoint {
  screenCoordX_t scx;
  screenCoordY_t scy;
};

/*
DoJoystickMouseDemo() initializes the joystick and the mouse and sets up
two Winged Yak logos, one controlled by the mouse and the other controlled
by the joystick.  A button click will illuminate the appropriate controlled
puck to a random solid color.  Demo runs until a key is pressed.
*/
void DoJoystickMouseDemo(
  void
)
{
  //show the splitscreen and print a "how to exit" message
  x_show_splitscreen();
  fntDemo.Printf( SplitScrnOffs, 0, 0, 15, "Press any key to exit." );

        //set up the input objects
  mouse.Init();
  mouse.Hide();
  joystick1.SetCenter();

  //load our yakBitmap
  yakBitmap ybmLogo;
  bFlag bfLoadedOK = ybmLogo.bfLoad( "logo.yak", &libDemo, yakBitmap::collidable );
  ASSERT( bfLoadedOK );

  screenPoint pntJoystick;
  screenPoint pntMouse;

  //set up bounds for movement
  screenCoordX_t scxRightBound = ScrnPhysicalPixelWidth - ybmLogo.iGetWidth();
  screenCoordY_t scyBottomBound = ScrnPhysicalHeight - ybmLogo.iGetHeight();

  loop {
        #define LINEHEIGHT 10
    //poll the joystick and move the joystick puck
    yakStick::Poll();
    pntJoystick.scx = joystick1.fLastX() * scxRightBound;
    pntJoystick.scy = joystick1.fLastY() * scyBottomBound;
    fntDemo.BgPrintf( SplitScrnOffs, 0, LINEHEIGHT, 15, 0, "Joystick puck: ( %d, %d )    ", pntJoystick.scx, pntJoystick.scy );
    //move the mouse puck
    pntMouse.scx = iBound( mouse.wX(), 0, scxRightBound );
    pntMouse.scy = iBound( mouse.wY(), 0, scyBottomBound );
    fntDemo.BgPrintf( SplitScrnOffs, 0, 2 * LINEHEIGHT, 15, 0, "Mouse puck: ( %d, %d )    ", pntMouse.scx, pntMouse.scy );
    //clear background
    yakPrimitive::FillRectangle( HiddenPageOffs, 0, 0, ScrnPhysicalPixelWidth, ScrnPhysicalHeight, 0 );
    //show joystick puck
    if ( joystick1.bfWasLastPressed( yakStick::button1 ) ) {
      ybmLogo.ShowCollision( HiddenPageOffs, pntJoystick.scx, pntJoystick.scy, random( 255 ) );
    }
    else {
            ybmLogo.Show( HiddenPageOffs, pntJoystick.scx, pntJoystick.scy, yakBitmap::masked );
    }
    //show mouse puck
    if ( mouse.bfIsPressed( yakMouse::leftButton ) ) {
      ybmLogo.ShowCollision( HiddenPageOffs, pntMouse.scx, pntMouse.scy, random( 255 ) );
    }
    else {
            ybmLogo.Show( HiddenPageOffs, pntMouse.scx, pntMouse.scy, yakBitmap::masked );
    }
    //now flip pages
    x_page_flip( 0, 0 );
    //quit this fun when the user presses a key
    exitWhen( kbhit() );
  }

  //clean up after the mouse
  mouse.Remove();
}


/*
main() does nothing but set up and run the joystick and mouse demo
*/
void main(
  void
)
{
  InitDemoObjects();
  SpewText( "joymdemo.txt" );
  SetUpGraphics();
  DoJoystickMouseDemo();
  QuitFromGraphics();
}
