#ifndef PLATFORM_H
#define PLATFORM_H

#include "factor.h"

#define FLOORHEIGHT 40

#define FLOOR 0x01 //floor bit.

class platformBeast :
	public facingActor {
public:
	int iDeltaX;
	int iDeltaY;
	int iGravity;
	int iMoveIncrement;
	int iJumpIncrement;
	int iHitPoints;
	int iAlignment;
	int iDamage;

	platformBeast( void );
	virtual void Advance( void );
	void Die( void );
	enum command {
		goLeft,
		goRight,
		jump
	};
	void Go( command myCommand );
};

class player;

class missile :
	public platformBeast {
public:
	int iRange;
	int iMissileNumber;
	int iDamage;
	player * pplyOwning;
	missile( void );
	virtual void Advance( void );
};

#define MAX_MISSILES 5
class player :
	public platformBeast {
public:
	missile * apmisMissiles[ MAX_MISSILES ];
	int iNumMissiles; //number of missiles he can fire
	int iMissileType;
	player( void );
	void FireMissile( void );
	virtual missile * pmisMissileGenerator( int iMissileType ) = 0;
	int iHitWithMissileType( platformBeast * ppltTarget );
};


class crawler :
	public platformBeast {
public:
	virtual void Advance( void );
};

#endif