#include "yakicons.h"
#include "sb1misc.h"

extern yakLib libDemo;
extern grumPlayer player1;

directionTable adirBeetIcons[ 3 ];

/*
loadIcons() loads the three directionTables used in the smart animap demo
*/
void loadIcons(
	void
)
{
	adirBeetIcons[ PLAYER ].Load( "", "swgrum", "sgrumjug", "segrum",
		"lgrumjug", "cgrumjug", "grumjug", "nwgrum", "ngrumjug", "negrum",
		&libDemo, yakBitmap::collidable );
	adirBeetIcons[ CLUB ].Load( "", "", "", "", "", "wclub", "", "","","", &libDemo, yakBitmap::collidable );
	adirBeetIcons[ BLOB ].Load( "", "", "cry1s", "", "cry1w", "cry1e", "cry1e", "", "cry1n", "", &libDemo, yakBitmap::collidable );
}



/*
default constructor for blobs.
*/
blob::blob(
	void )
{
	iHitPoints = 1;
	iDamage =1;
	iAlignment = -1;
	iMoveIncrement = 4;
	iGravity=1;
	AssignNewDirectionTable( &( adirBeetIcons[ BLOB ] ), facingActor::oneFace );
};


/*
default constructor for grumPlayer.
*/
grumPlayer::grumPlayer(
	void
) : player()
{
	iMissileType = CLUB;
	iMoveIncrement = 5;
	iJumpIncrement = 12;
	iNumMissiles = 3;
	iHitPoints = 24;
	iGravity=1;
};


/*
specific constructor for club()
*/
club::club(
	grumPlayer * pgrmOwner
) : missile()
{
	iDamage = 1;
	iHitPoints = 1;
	iRange = 15;
	iMoveIncrement = 12;
	iGravity = 0;
	AssignNewDirectionTable( &( adirBeetIcons[ CLUB ]), facingActor::oneFace );
	pplyOwning = pgrmOwner;
};


/*
missileGenerator() generates a pointer to a new missile of the given type.
*/
missile * grumPlayer::pmisMissileGenerator(
	int iMissileType
)
{
	missile * pmis = NULL;
	switch ( iMissileType )	{
		case CLUB:
			pmis = new club( this );
		break;
	}
	return pmis;
}