#include "yakicons.h"
#include "demorts.h"
#include <conio.h>
#include "yaksound.h"

extern yakLib libDemo;
extern yakFont fntDemo;
extern yakPalette palDemo;

//DoSoundDemo display logo while playing .wav file in background
void DoSoundDemo(
        void
)
{
  //first load our logo yakBitmap
  yakBitmap ybmLogo;
  bFlag bfLoadedOK = success;
  bfLoadedOK = ybmLogo.bfLoad( "yak1.yak", &libDemo );
  ASSERT( bfLoadedOK );
  //now we'll set up a white and working palette
  yakPalette palWorking;
  yakPalette palWhite;
  for ( int i = 0; i < 255; ++i ) {
    palWorking.SetColor( i, 63, 63, 63 );
    palWhite.SetColor( i, 63, 63, 63 );
  }
  palWorking.Put();
  //draw the yakBitmap ( all is black )
  ybmLogo.Show( VisiblePageOffs, 20, 20 );
  //okay.  We've shown our yakBitmap; time to play our sound and do our demo!
  yakSample smpWoosh;
  bfLoadedOK = smpWoosh.bfLoad( "yak2.wav", &libDemo );
  ASSERT( bfLoadedOK );
  smpWoosh.Play( 255 );
  //now set up a Middle palette to be normal but with colors 41 and
  //47 black; we do this so that we can fade in the "audience" line
  //later.
  yakPalette palMiddle;
  //set it to be the demo palette
  palMiddle.SetToTween( &palDemo, &palDemo, 1, 1 );
  palMiddle.SetColor( 41, 0, 0, 0 );
  palMiddle.SetColor( 47, 0, 0, 0 );
  palMiddle.SetColor( 44, 0, 0, 0 );
  //now we fade in from the white palette to the Middle palette
  //using SetToTween
  #define FIRSTFADE_STEPS 250
  for ( i = 0; i < FIRSTFADE_STEPS; ++i ) {
    palWorking.SetToTween( &palWhite, &palMiddle, i, FIRSTFADE_STEPS );
    palWorking.Put();
  }
  //now pause for a given length of time
  #define PAUSE_DELAY 1500
  delay( PAUSE_DELAY );
  //now set up our second target palette to be the "final" palette;
  //we could easily reuse one of the previous palettes, but this
  //makes more sense reading it, and we're not exhausting system
  //resources with this tiny a program
  yakPalette palFinal;
  //set it to be the first target palette
  palFinal.SetToTween( &palMiddle, &palMiddle, 1, 1 );
  //now make the "audience..." line colors visible
  palFinal.SetColor( 47, 63, 63, 63 );
  palFinal.SetColor( 44, 31, 31, 31 );
  palFinal.SetColor( 41, 0, 0, 0 );
  //now set the middle palette to have white for those colors so we
  //can "spring" them into brightness
  palMiddle.SetColor( 47, 63, 63, 63 );
  palMiddle.SetColor( 44, 63, 63, 63 );
  palMiddle.SetColor( 41, 63, 63, 63 );
  //now fade from the new "middle" palette to the "final" palette
  #define SECONDFADE_STEPS 50
  for ( i = 0; i < SECONDFADE_STEPS; ++i ) {
    palWorking.SetToTween( &palMiddle, &palFinal, i, SECONDFADE_STEPS );
    palWorking.Put();
  }
        getch();
}

/*
main() does nothing but set up and run the sound demo
*/
void main(
  void
)
{
	InitDemoObjects();
  SpewText( "soundemo.txt" );
  bFlag bfSoundOK = yakSound::bfInitialize( true );
  if ( !bfSoundOK ) {
    ExitWithErrorMessage( "Could not initialize sound routines; please run setup.exe\n" );
  }
  SetUpGraphics();
  DoSoundDemo();
  QuitFromGraphics();
}
