#include "yakicons.h"
#include "demorts.h"
#include <string.h>
#ifdef __386__
//#include <mem.h>
#else
#include <alloc.h>
#endif

#ifdef __386__
#define random( limit ) (rand() % limit)
#endif

char * pcScrollerText = "\
Arrows scroll up/down, escape quits using the window.  These scroller \
windows exist just to show you that the windowing system works.  They can \
be resized at will and destroy themselves on closure.\0\0";

extern yakLib libDemo;
extern yakFont fntDemo;

#define C_QUIT 10
#define C_ADD_SCROLLER 11
#define C_ADD_YAKPANEL 12
#define C_BUTTONPRESS 13
#define C_LABELPRESS 14

/*
CreateDemoPanel() sets up a panel with a demonstration set of gadgets.
*/
yakPanel * ppnlCreateDemoPanel(
  void
)
{
  #define PANELWIDTH 100
  #define PANELHEIGHT 100
  yakPanel * ppnl;
  //create the new panel
  ppnl = new yakPanel( 0, 0, PANELWIDTH, PANELHEIGHT );
  //make sure it's a temporary panel, so it will be destroyed
  //automatically on closure
  ppnl->bfIsTemporary = true;
        //copy the new panel title
        strcpy( ppnl->acTitle, "Demo yakPanel" );
  //set its new screen position
        ppnl->scx = random( ScrnPhysicalPixelWidth - PANELWIDTH );
        ppnl->scy = random( ScrnPhysicalHeight - PANELHEIGHT );
  //and now add all its appropriate demonstration gadgets
        ppnl->AddNode(
                new gadgetNode( new toggleSwitch( 2, 10, '!', 0, "light", &libDemo ),
                new gadgetNode( new toggleSwitch( 18, 10, '!', 0, "light", &libDemo ),
                new gadgetNode( new toggleSwitch( 34, 10, '!', 0, "light", &libDemo ),
                new gadgetNode( new toggleSwitch( 49, 10, '!', 0, "toggl", &libDemo ),
                new gadgetNode( new toggleSwitch( 65, 10, '!', 0, "toggl", &libDemo ),
                new gadgetNode( new toggleSwitch( 81, 10, '!', 0, "toggl", &libDemo ),
                new gadgetNode( new toggleSwitch( 2, 60,  '!', 0, "grumjug", &libDemo, gadget::touchPad ),
                new gadgetNode( new slider( 2, 26, 0, 0, 50, 10, 0, 100 ),
                new gadgetNode( new slider( 2, 37, 0, 0, 50, 15, 0, 100, 36, 10, 47 ),
                new gadgetNode( new button( 2, 80, '1', C_BUTTONPRESS, "button", &libDemo ),
                new gadgetNode( new label( 35, 85, '2', C_LABELPRESS, "Press Me!", 47, 1 ),
                &ppnl->nodTail
        ))))))))))));
  return ppnl;
}


/*
SetUpMenu() sets attributes of the main winDemo menu ( so that it cannot
be closed or drug ) and adds the appropriate gadgets
*/
void SetUpMenu(
  yakPanel * ppnl
)
{
        //set up the menu
        ppnl->eFlags = (yakWindow::flags)(ppnl->eFlags & ~(yakWindow::isCloseable) | yakWindow::isDraggable );
        ppnl->AddNode(
                new gadgetNode( new label( 2, 10,'Q', C_QUIT, "Quit demo", 15, 0 ),
                new gadgetNode( new label( 2, 20,'!', C_ADD_SCROLLER, "Add a demo scroller", 15, 0 ),
                new gadgetNode( new label( 2, 30,'!', C_ADD_YAKPANEL, "Add a yakPanel with gadgets", 15, 0 ),
                &ppnl->nodTail ))));
        strcpy( ppnl->acTitle, "Main Menu" );
}


/*
pscrlCreateDemoScroller() creates a new window o' text for scrolling fun
*/
yakScroller * pscrlCreateDemoScroller(
  void
)
{
        #define MAXWIDTH 100
  #define MAXHEIGHT  100
  yakScroller * pscrl = new yakScroller( 0, 0, random( MAXWIDTH ) + 50, random( MAXHEIGHT ) + 50, pcScrollerText );
  //move to a random location
  pscrl->scx = random( ScrnPhysicalPixelWidth - pscrl->iWidth );
  pscrl->scy = random( ScrnPhysicalHeight - pscrl->iHeight );
  //set random colors
  pscrl->colTitleColor = random( 255 );
  pscrl->colTextColor = random( 255 );
  //set up a title
  strcpy( pscrl->acTitle, "Demo" );
  //make sure it's temporary so it autodestructs when closed
  pscrl->bfIsTemporary = true;
  return pscrl;
}


/*
DoYakWindowsDemo() draws a menu and allows the user to play with it.
*/
void DoYakWindowsDemo(
  void
)
{
        //set up the menu
  yakPanel pnlMenu( 0, 0, 200, 50 );
  SetUpMenu( &pnlMenu );
  pnlMenu.Open();
  //now do the main loop
  gadgetID_t gidCommand = 0;
  loop {
    #ifndef __386__
    fntDemo.BgPrintf( VisiblePageOffs, 0, ScrnPhysicalHeight - fntDemo.bCharHeight, 15, 0, "Free: %ld", coreleft() );
    #endif
    gidCommand = yakWindow::gidAdvance();
    exitWhen( gidCommand == C_QUIT );
    switch( gidCommand ) {
      case C_ADD_YAKPANEL: {
        yakPanel * ppnl = ppnlCreateDemoPanel();
        ppnl->Open();
      }
      break;
      case C_ADD_SCROLLER: {
        yakScroller * pscrl = pscrlCreateDemoScroller();
        pscrl->Open();
      }
      break;
    }
  }
}


/*
main() just sets up graphics mode, runs the windows demo, then exits
*/
void main(
        void
)
{
  InitDemoObjects();
  SpewText( "windemo.txt" );
  SetUpGraphics();
  x_page_flip( 0, 0 );
  mouse.Init();
  DoYakWindowsDemo();
  mouse.Remove();
  QuitFromGraphics();
}
